/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) HengShanCompany 2019-2029. All rights reserved.
 * Description: ion
 * Author: HengShan
 * Create: 2019-03-16
 */

#ifndef _ION_PAGE_MM_H
#define _ION_PAGE_MM_H

#include <asm/page.h>
#include <linux/dma-mapping.h>
#include <linux/err.h>
#include <linux/highmem.h>
#include <linux/mm.h>
#include <linux/scatterlist.h>
#include <linux/seq_file.h>
#include <linux/slab.h>
#include <linux/vmalloc.h>
#include <linux/cma.h>
#include <linux/hengshan/drv_iommu.h>
#include <linux/hengshan/securec.h>
#include <../drivers/staging/android/ion/ion.h>

extern size_t g_ion_pool_limit;

struct ion_system_heap;

int ion_system_heap_allocate(struct ion_heap *heap,
			     struct ion_buffer *buffer,
			     unsigned long size,
			     unsigned long flags);

void ion_system_heap_free(struct ion_buffer *buffer);

int ion_system_heap_shrink(struct ion_heap *heap, gfp_t gfp_mask,
			   int nr_to_scan);
struct ion_heap *__ion_system_heap_create(void);

/* cma heap   */
#define INVALID_BASE    0
#define INVALID_SIZE    0
#define NAME_LEN_MAX   64
#define CMA_HEAP_MAX_NUM        3
struct drv_cma_data {
	char name[NAME_LEN_MAX];
	unsigned int  heap_id;
	phys_addr_t phys_addr;
	size_t size;
};
extern struct drv_cma_data g_cma_data[CMA_HEAP_MAX_NUM];

int ion_cma_allocate(struct ion_heap *heap,
		     struct ion_buffer *buffer,
		     unsigned long len,
		     unsigned long flags);

void ion_cma_free(struct ion_buffer *buffer);

int ion_cma_phys(struct ion_heap *heap, struct ion_buffer *buffer,
		 phys_addr_t *addr, size_t *len);
int ion_heap_map_ree_iommu(struct ion_buffer *buffer,
			   struct ion_iommu_map *map_data);
void ion_heap_unmap_ree_iommu(struct ion_buffer *buffer,
			      struct ion_iommu_map *map_data);

#endif /* _ION_PAGE_MM_H */
